﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Collections;
using Telerik.Web.UI;

public partial class RotatorUserControl : System.Web.UI.UserControl
{
	protected void Page_Load(object sender, EventArgs e)
	{
		ArrayList al = new ArrayList();
		ExamQuestionsSet qSet = (ExamQuestionsSet)Session["QSET"];
		for (int i = 0; i < qSet.ExamQList.Count; i++)
			al.Add("question_panel.ascx");

		RadRotator rotator1 = new RadRotator();
		rotator1.ID = "questionPanel";

		rotator1.ItemTemplate = new RotatorTemplate(this.Page);
		rotator1.DataSource = al;
		rotator1.Width = 320;
		rotator1.Height = 300;
		rotator1.ScrollDirection = RotatorScrollDirection.Left;
		rotator1.ScrollDuration = 500;
		rotator1.RotatorType = RotatorType.FromCode;
		PlaceHolder1.Controls.Add(rotator1);
		rotator1.DataBind();

		// the client-side scripts, used for the rotation are registered on the server-side
		string prevLinkHandler = "$get('prev').onclick=function(){showNextItem(this, $find('"+rotator1.ClientID+"'), Telerik.Web.UI.RotatorScrollDirection.Down); return false;};";
		string nextLinkHandler = "$get('next').onclick=function(){showNextItem(this, $find('"+rotator1.ClientID+"'), Telerik.Web.UI.RotatorScrollDirection.Up); return false;};";

		ScriptManager.RegisterStartupScript(this, this.GetType(), "rotationScript", prevLinkHandler + nextLinkHandler, true);
	}
}

class RotatorTemplate : ITemplate
{
	Page page;
	public RotatorTemplate(Page p)
	{
		page = p;
	}

	public void InstantiateIn(Control c)
	{
		PlaceHolder placeholder1 = new PlaceHolder();
		placeholder1.ID = "controlOne";
		placeholder1.DataBinding += new EventHandler(OnPlaceholderBinding);
		c.Controls.Add(placeholder1);
	}

	void OnPlaceholderBinding(object sender, EventArgs e)
	{
		PlaceHolder placeholder1 = (PlaceHolder)sender;
		String userControlName = (String)DataBinder.Eval(placeholder1.BindingContainer, "DataItem");
		ITemplate userControl1 = page.LoadTemplate(userControlName);
		userControl1.InstantiateIn(placeholder1);
	}
}

public class ExamQuestionsSet
{
	public List<ExamQuestion> ExamQList { get; set; }
	public ExamQuestionsSet()
	{
		ExamQList = new List<ExamQuestion>();
	}
}
public class ExamQuestion
{
	public string QText { get; set; }
	public int ID { get; set; }
	public List<ExamAnswer> ExamAList { get; set; }
	public bool IsShown { get; set; }
	public ExamQuestion()
	{
		ExamAList = new List<ExamAnswer>();
	}
}
public class ExamAnswer
{
	public string AText { get; set; }
	public bool IsSelected { get; set; }
	public int ID { get; set; }
}